"""
/***************************************************************************
 NetworkStorePlugin
                                 A QGIS plugin
 export layers to kisters network store
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                             -------------------
        begin                : 2022-06-01
        copyright            : (C) 2022 by Attila Bibok
        email                : Attila.bibok@kisters.net
        git sha              : $Format:%H$
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 This script initializes the plugin, making it known to QGIS.
"""

# Manage external dependencies. KEEP IT MINIMAL, painful in windows
# NOTE: If you installed QGIS with flatpak (usually on Mint, NEON), you have to manually add the dependencies since, flatpak's sandboxing prevent's detecting pip/pip3 properly
import subprocess
import sys

try:
    import kisters.network_store.model_library.water
except:
    subprocess.check_call(
        [
            sys.executable,
            "-m",
            "pip",
            "install",
            "kisters.network-store.model-library.water",
        ]
    )

try:
    from kisters.network_store.client.network import Network
except:
    subprocess.check_call(
        [sys.executable, "-m", "pip", "install", "kisters.network_store.client.network"]
    )
    subprocess.check_call(
        [
            sys.executable,
            "-m",
            "pip",
            "install",
            "kisters.network_store.client.network[water]",
        ]
    )
# TODO: replace with network-store.client and parsing settings string
try:
    from kisters.water.rest_client import RESTClient
except:
    subprocess.check_call(
        [sys.executable, "-m", "pip", "install", "kisters.water.rest_client"]
    )


# noinspection PyPep8Naming
def classFactory(iface):  # pylint: disable=invalid-name
    """Load NetworkStorePlugin class from file NetworkStorePlugin.

    :param iface: A QGIS interface instance.
    :type iface: QgsInterface
    """
    from .network_store import NetworkStorePlugin

    return NetworkStorePlugin(iface)
